// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	v1alpha1 "kf-operator/pkg/apis/operand/v1alpha1"
	scheme "kf-operator/pkg/client/clientset/versioned/scheme"
	"time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ClusterActiveOperandsGetter has a method to return a ClusterActiveOperandInterface.
// A group's client should implement this interface.
type ClusterActiveOperandsGetter interface {
	ClusterActiveOperands() ClusterActiveOperandInterface
}

// ClusterActiveOperandInterface has methods to work with ClusterActiveOperand resources.
type ClusterActiveOperandInterface interface {
	Create(ctx context.Context, clusterActiveOperand *v1alpha1.ClusterActiveOperand, opts v1.CreateOptions) (*v1alpha1.ClusterActiveOperand, error)
	Update(ctx context.Context, clusterActiveOperand *v1alpha1.ClusterActiveOperand, opts v1.UpdateOptions) (*v1alpha1.ClusterActiveOperand, error)
	UpdateStatus(ctx context.Context, clusterActiveOperand *v1alpha1.ClusterActiveOperand, opts v1.UpdateOptions) (*v1alpha1.ClusterActiveOperand, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.ClusterActiveOperand, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.ClusterActiveOperandList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ClusterActiveOperand, err error)
	ClusterActiveOperandExpansion
}

// clusterActiveOperands implements ClusterActiveOperandInterface
type clusterActiveOperands struct {
	client rest.Interface
}

// newClusterActiveOperands returns a ClusterActiveOperands
func newClusterActiveOperands(c *OperandV1alpha1Client) *clusterActiveOperands {
	return &clusterActiveOperands{
		client: c.RESTClient(),
	}
}

// Get takes name of the clusterActiveOperand, and returns the corresponding clusterActiveOperand object, and an error if there is any.
func (c *clusterActiveOperands) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.ClusterActiveOperand, err error) {
	result = &v1alpha1.ClusterActiveOperand{}
	err = c.client.Get().
		Resource("clusteractiveoperands").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ClusterActiveOperands that match those selectors.
func (c *clusterActiveOperands) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.ClusterActiveOperandList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.ClusterActiveOperandList{}
	err = c.client.Get().
		Resource("clusteractiveoperands").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested clusterActiveOperands.
func (c *clusterActiveOperands) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("clusteractiveoperands").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a clusterActiveOperand and creates it.  Returns the server's representation of the clusterActiveOperand, and an error, if there is any.
func (c *clusterActiveOperands) Create(ctx context.Context, clusterActiveOperand *v1alpha1.ClusterActiveOperand, opts v1.CreateOptions) (result *v1alpha1.ClusterActiveOperand, err error) {
	result = &v1alpha1.ClusterActiveOperand{}
	err = c.client.Post().
		Resource("clusteractiveoperands").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(clusterActiveOperand).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a clusterActiveOperand and updates it. Returns the server's representation of the clusterActiveOperand, and an error, if there is any.
func (c *clusterActiveOperands) Update(ctx context.Context, clusterActiveOperand *v1alpha1.ClusterActiveOperand, opts v1.UpdateOptions) (result *v1alpha1.ClusterActiveOperand, err error) {
	result = &v1alpha1.ClusterActiveOperand{}
	err = c.client.Put().
		Resource("clusteractiveoperands").
		Name(clusterActiveOperand.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(clusterActiveOperand).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *clusterActiveOperands) UpdateStatus(ctx context.Context, clusterActiveOperand *v1alpha1.ClusterActiveOperand, opts v1.UpdateOptions) (result *v1alpha1.ClusterActiveOperand, err error) {
	result = &v1alpha1.ClusterActiveOperand{}
	err = c.client.Put().
		Resource("clusteractiveoperands").
		Name(clusterActiveOperand.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(clusterActiveOperand).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the clusterActiveOperand and deletes it. Returns an error if one occurs.
func (c *clusterActiveOperands) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("clusteractiveoperands").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *clusterActiveOperands) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("clusteractiveoperands").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched clusterActiveOperand.
func (c *clusterActiveOperands) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ClusterActiveOperand, err error) {
	result = &v1alpha1.ClusterActiveOperand{}
	err = c.client.Patch(pt).
		Resource("clusteractiveoperands").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
