//go:build !ignore_autogenerated
// +build !ignore_autogenerated

// Copyright 2020 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by deepcopy-gen. DO NOT EDIT.

package v1alpha1

import (
	config "github.com/google/kf/v2/pkg/apis/kf/config"
	v1 "k8s.io/api/core/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	v1beta1 "knative.dev/pkg/apis/duck/v1beta1"
)

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *App) DeepCopyInto(out *App) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new App.
func (in *App) DeepCopy() *App {
	if in == nil {
		return nil
	}
	out := new(App)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *App) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AppAutoscalingRule) DeepCopyInto(out *AppAutoscalingRule) {
	*out = *in
	if in.Target != nil {
		in, out := &in.Target, &out.Target
		*out = new(int32)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AppAutoscalingRule.
func (in *AppAutoscalingRule) DeepCopy() *AppAutoscalingRule {
	if in == nil {
		return nil
	}
	out := new(AppAutoscalingRule)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AppList) DeepCopyInto(out *AppList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]App, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AppList.
func (in *AppList) DeepCopy() *AppList {
	if in == nil {
		return nil
	}
	out := new(AppList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *AppList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AppRef) DeepCopyInto(out *AppRef) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AppRef.
func (in *AppRef) DeepCopy() *AppRef {
	if in == nil {
		return nil
	}
	out := new(AppRef)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AppRouteStatus) DeepCopyInto(out *AppRouteStatus) {
	*out = *in
	out.QualifiedRouteBinding = in.QualifiedRouteBinding
	out.VirtualService = in.VirtualService
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AppRouteStatus.
func (in *AppRouteStatus) DeepCopy() *AppRouteStatus {
	if in == nil {
		return nil
	}
	out := new(AppRouteStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AppSpec) DeepCopyInto(out *AppSpec) {
	*out = *in
	in.Build.DeepCopyInto(&out.Build)
	in.Template.DeepCopyInto(&out.Template)
	in.Instances.DeepCopyInto(&out.Instances)
	if in.Routes != nil {
		in, out := &in.Routes, &out.Routes
		*out = make([]RouteWeightBinding, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AppSpec.
func (in *AppSpec) DeepCopy() *AppSpec {
	if in == nil {
		return nil
	}
	out := new(AppSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AppSpecAutoscaling) DeepCopyInto(out *AppSpecAutoscaling) {
	*out = *in
	if in.MinReplicas != nil {
		in, out := &in.MinReplicas, &out.MinReplicas
		*out = new(int32)
		**out = **in
	}
	if in.MaxReplicas != nil {
		in, out := &in.MaxReplicas, &out.MaxReplicas
		*out = new(int32)
		**out = **in
	}
	if in.Rules != nil {
		in, out := &in.Rules, &out.Rules
		*out = make([]AppAutoscalingRule, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AppSpecAutoscaling.
func (in *AppSpecAutoscaling) DeepCopy() *AppSpecAutoscaling {
	if in == nil {
		return nil
	}
	out := new(AppSpecAutoscaling)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AppSpecBuild) DeepCopyInto(out *AppSpecBuild) {
	*out = *in
	if in.Spec != nil {
		in, out := &in.Spec, &out.Spec
		*out = new(BuildSpec)
		(*in).DeepCopyInto(*out)
	}
	if in.Image != nil {
		in, out := &in.Image, &out.Image
		*out = new(string)
		**out = **in
	}
	if in.BuildRef != nil {
		in, out := &in.BuildRef, &out.BuildRef
		*out = new(v1.LocalObjectReference)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AppSpecBuild.
func (in *AppSpecBuild) DeepCopy() *AppSpecBuild {
	if in == nil {
		return nil
	}
	out := new(AppSpecBuild)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AppSpecInstances) DeepCopyInto(out *AppSpecInstances) {
	*out = *in
	in.Autoscaling.DeepCopyInto(&out.Autoscaling)
	if in.Replicas != nil {
		in, out := &in.Replicas, &out.Replicas
		*out = new(int32)
		**out = **in
	}
	if in.DeprecatedExactly != nil {
		in, out := &in.DeprecatedExactly, &out.DeprecatedExactly
		*out = new(int32)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AppSpecInstances.
func (in *AppSpecInstances) DeepCopy() *AppSpecInstances {
	if in == nil {
		return nil
	}
	out := new(AppSpecInstances)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AppSpecTemplate) DeepCopyInto(out *AppSpecTemplate) {
	*out = *in
	in.Spec.DeepCopyInto(&out.Spec)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AppSpecTemplate.
func (in *AppSpecTemplate) DeepCopy() *AppSpecTemplate {
	if in == nil {
		return nil
	}
	out := new(AppSpecTemplate)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AppStatus) DeepCopyInto(out *AppStatus) {
	*out = *in
	in.Status.DeepCopyInto(&out.Status)
	in.BuildStatusFields.DeepCopyInto(&out.BuildStatusFields)
	if in.ServiceBindingNames != nil {
		in, out := &in.ServiceBindingNames, &out.ServiceBindingNames
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.ServiceBindingConditions != nil {
		in, out := &in.ServiceBindingConditions, &out.ServiceBindingConditions
		*out = make(v1beta1.Conditions, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.Routes != nil {
		in, out := &in.Routes, &out.Routes
		*out = make([]AppRouteStatus, len(*in))
		copy(*out, *in)
	}
	if in.URLs != nil {
		in, out := &in.URLs, &out.URLs
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.RouteConditions != nil {
		in, out := &in.RouteConditions, &out.RouteConditions
		*out = make(v1beta1.Conditions, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.Volumes != nil {
		in, out := &in.Volumes, &out.Volumes
		*out = make([]AppVolumeStatus, len(*in))
		copy(*out, *in)
	}
	in.Instances.DeepCopyInto(&out.Instances)
	out.Tasks = in.Tasks
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AppStatus.
func (in *AppStatus) DeepCopy() *AppStatus {
	if in == nil {
		return nil
	}
	out := new(AppStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AppTaskStatus) DeepCopyInto(out *AppTaskStatus) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AppTaskStatus.
func (in *AppTaskStatus) DeepCopy() *AppTaskStatus {
	if in == nil {
		return nil
	}
	out := new(AppTaskStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AppVolumeStatus) DeepCopyInto(out *AppVolumeStatus) {
	*out = *in
	out.UidGid = in.UidGid
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AppVolumeStatus.
func (in *AppVolumeStatus) DeepCopy() *AppVolumeStatus {
	if in == nil {
		return nil
	}
	out := new(AppVolumeStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AutoscalingRuleMetricValueStatus) DeepCopyInto(out *AutoscalingRuleMetricValueStatus) {
	*out = *in
	if in.AverageValue != nil {
		in, out := &in.AverageValue, &out.AverageValue
		x := (*in).DeepCopy()
		*out = &x
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AutoscalingRuleMetricValueStatus.
func (in *AutoscalingRuleMetricValueStatus) DeepCopy() *AutoscalingRuleMetricValueStatus {
	if in == nil {
		return nil
	}
	out := new(AutoscalingRuleMetricValueStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AutoscalingRuleStatus) DeepCopyInto(out *AutoscalingRuleStatus) {
	*out = *in
	in.AppAutoscalingRule.DeepCopyInto(&out.AppAutoscalingRule)
	in.Current.DeepCopyInto(&out.Current)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AutoscalingRuleStatus.
func (in *AutoscalingRuleStatus) DeepCopy() *AutoscalingRuleStatus {
	if in == nil {
		return nil
	}
	out := new(AutoscalingRuleStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *BindingOSBStatus) DeepCopyInto(out *BindingOSBStatus) {
	*out = *in
	if in.Binding != nil {
		in, out := &in.Binding, &out.Binding
		*out = new(OSBState)
		(*in).DeepCopyInto(*out)
	}
	if in.Bound != nil {
		in, out := &in.Bound, &out.Bound
		*out = new(OSBState)
		(*in).DeepCopyInto(*out)
	}
	if in.BindFailed != nil {
		in, out := &in.BindFailed, &out.BindFailed
		*out = new(OSBState)
		(*in).DeepCopyInto(*out)
	}
	if in.Unbinding != nil {
		in, out := &in.Unbinding, &out.Unbinding
		*out = new(OSBState)
		(*in).DeepCopyInto(*out)
	}
	if in.Unbound != nil {
		in, out := &in.Unbound, &out.Unbound
		*out = new(OSBState)
		(*in).DeepCopyInto(*out)
	}
	if in.UnbindFailed != nil {
		in, out := &in.UnbindFailed, &out.UnbindFailed
		*out = new(OSBState)
		(*in).DeepCopyInto(*out)
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new BindingOSBStatus.
func (in *BindingOSBStatus) DeepCopy() *BindingOSBStatus {
	if in == nil {
		return nil
	}
	out := new(BindingOSBStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *BindingType) DeepCopyInto(out *BindingType) {
	*out = *in
	if in.App != nil {
		in, out := &in.App, &out.App
		*out = new(AppRef)
		**out = **in
	}
	if in.Route != nil {
		in, out := &in.Route, &out.Route
		*out = new(RouteRef)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new BindingType.
func (in *BindingType) DeepCopy() *BindingType {
	if in == nil {
		return nil
	}
	out := new(BindingType)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *BindingVolumeParams) DeepCopyInto(out *BindingVolumeParams) {
	*out = *in
	out.UidGid = in.UidGid
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new BindingVolumeParams.
func (in *BindingVolumeParams) DeepCopy() *BindingVolumeParams {
	if in == nil {
		return nil
	}
	out := new(BindingVolumeParams)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *BindingVolumeStatus) DeepCopyInto(out *BindingVolumeStatus) {
	*out = *in
	out.UidGid = in.UidGid
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new BindingVolumeStatus.
func (in *BindingVolumeStatus) DeepCopy() *BindingVolumeStatus {
	if in == nil {
		return nil
	}
	out := new(BindingVolumeStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *BrokeredInstance) DeepCopyInto(out *BrokeredInstance) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new BrokeredInstance.
func (in *BrokeredInstance) DeepCopy() *BrokeredInstance {
	if in == nil {
		return nil
	}
	out := new(BrokeredInstance)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Build) DeepCopyInto(out *Build) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Build.
func (in *Build) DeepCopy() *Build {
	if in == nil {
		return nil
	}
	out := new(Build)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Build) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *BuildList) DeepCopyInto(out *BuildList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Build, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new BuildList.
func (in *BuildList) DeepCopy() *BuildList {
	if in == nil {
		return nil
	}
	out := new(BuildList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *BuildList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *BuildParam) DeepCopyInto(out *BuildParam) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new BuildParam.
func (in *BuildParam) DeepCopy() *BuildParam {
	if in == nil {
		return nil
	}
	out := new(BuildParam)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *BuildSpec) DeepCopyInto(out *BuildSpec) {
	*out = *in
	out.SourcePackage = in.SourcePackage
	out.BuildTaskRef = in.BuildTaskRef
	if in.Params != nil {
		in, out := &in.Params, &out.Params
		*out = make([]BuildParam, len(*in))
		copy(*out, *in)
	}
	if in.Env != nil {
		in, out := &in.Env, &out.Env
		*out = make([]v1.EnvVar, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.NodeSelector != nil {
		in, out := &in.NodeSelector, &out.NodeSelector
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new BuildSpec.
func (in *BuildSpec) DeepCopy() *BuildSpec {
	if in == nil {
		return nil
	}
	out := new(BuildSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *BuildStatus) DeepCopyInto(out *BuildStatus) {
	*out = *in
	in.Status.DeepCopyInto(&out.Status)
	in.BuildStatusFields.DeepCopyInto(&out.BuildStatusFields)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new BuildStatus.
func (in *BuildStatus) DeepCopy() *BuildStatus {
	if in == nil {
		return nil
	}
	out := new(BuildStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *BuildStatusFields) DeepCopyInto(out *BuildStatusFields) {
	*out = *in
	if in.StartTime != nil {
		in, out := &in.StartTime, &out.StartTime
		*out = (*in).DeepCopy()
	}
	if in.CompletionTime != nil {
		in, out := &in.CompletionTime, &out.CompletionTime
		*out = (*in).DeepCopy()
	}
	if in.Duration != nil {
		in, out := &in.Duration, &out.Duration
		*out = new(metav1.Duration)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new BuildStatusFields.
func (in *BuildStatusFields) DeepCopy() *BuildStatusFields {
	if in == nil {
		return nil
	}
	out := new(BuildStatusFields)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *BuildTaskRef) DeepCopyInto(out *BuildTaskRef) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new BuildTaskRef.
func (in *BuildTaskRef) DeepCopy() *BuildTaskRef {
	if in == nil {
		return nil
	}
	out := new(BuildTaskRef)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ClusterServiceBroker) DeepCopyInto(out *ClusterServiceBroker) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ClusterServiceBroker.
func (in *ClusterServiceBroker) DeepCopy() *ClusterServiceBroker {
	if in == nil {
		return nil
	}
	out := new(ClusterServiceBroker)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *ClusterServiceBroker) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ClusterServiceBrokerList) DeepCopyInto(out *ClusterServiceBrokerList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]ClusterServiceBroker, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ClusterServiceBrokerList.
func (in *ClusterServiceBrokerList) DeepCopy() *ClusterServiceBrokerList {
	if in == nil {
		return nil
	}
	out := new(ClusterServiceBrokerList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *ClusterServiceBrokerList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ClusterServiceBrokerSpec) DeepCopyInto(out *ClusterServiceBrokerSpec) {
	*out = *in
	in.CommonServiceBrokerSpec.DeepCopyInto(&out.CommonServiceBrokerSpec)
	out.Credentials = in.Credentials
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ClusterServiceBrokerSpec.
func (in *ClusterServiceBrokerSpec) DeepCopy() *ClusterServiceBrokerSpec {
	if in == nil {
		return nil
	}
	out := new(ClusterServiceBrokerSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *CommonServiceBrokerSpec) DeepCopyInto(out *CommonServiceBrokerSpec) {
	*out = *in
	if in.VolumeBrokerSpec != nil {
		in, out := &in.VolumeBrokerSpec, &out.VolumeBrokerSpec
		*out = new(VolumeBrokerSpec)
		(*in).DeepCopyInto(*out)
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new CommonServiceBrokerSpec.
func (in *CommonServiceBrokerSpec) DeepCopy() *CommonServiceBrokerSpec {
	if in == nil {
		return nil
	}
	out := new(CommonServiceBrokerSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *CommonServiceBrokerStatus) DeepCopyInto(out *CommonServiceBrokerStatus) {
	*out = *in
	in.Status.DeepCopyInto(&out.Status)
	if in.Services != nil {
		in, out := &in.Services, &out.Services
		*out = make([]ServiceOffering, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new CommonServiceBrokerStatus.
func (in *CommonServiceBrokerStatus) DeepCopy() *CommonServiceBrokerStatus {
	if in == nil {
		return nil
	}
	out := new(CommonServiceBrokerStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *InstanceStatus) DeepCopyInto(out *InstanceStatus) {
	*out = *in
	if in.AutoscalingStatus != nil {
		in, out := &in.AutoscalingStatus, &out.AutoscalingStatus
		*out = make([]AutoscalingRuleStatus, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new InstanceStatus.
func (in *InstanceStatus) DeepCopy() *InstanceStatus {
	if in == nil {
		return nil
	}
	out := new(InstanceStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in LocalObjectReferences) DeepCopyInto(out *LocalObjectReferences) {
	{
		in := &in
		*out = make(LocalObjectReferences, len(*in))
		copy(*out, *in)
		return
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LocalObjectReferences.
func (in LocalObjectReferences) DeepCopy() LocalObjectReferences {
	if in == nil {
		return nil
	}
	out := new(LocalObjectReferences)
	in.DeepCopyInto(out)
	return *out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NamespacedObjectReference) DeepCopyInto(out *NamespacedObjectReference) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NamespacedObjectReference.
func (in *NamespacedObjectReference) DeepCopy() *NamespacedObjectReference {
	if in == nil {
		return nil
	}
	out := new(NamespacedObjectReference)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OSBInstance) DeepCopyInto(out *OSBInstance) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OSBInstance.
func (in *OSBInstance) DeepCopy() *OSBInstance {
	if in == nil {
		return nil
	}
	out := new(OSBInstance)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OSBState) DeepCopyInto(out *OSBState) {
	*out = *in
	if in.OperationKey != nil {
		in, out := &in.OperationKey, &out.OperationKey
		*out = new(string)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OSBState.
func (in *OSBState) DeepCopy() *OSBState {
	if in == nil {
		return nil
	}
	out := new(OSBState)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OSBStatus) DeepCopyInto(out *OSBStatus) {
	*out = *in
	if in.Provisioning != nil {
		in, out := &in.Provisioning, &out.Provisioning
		*out = new(OSBState)
		(*in).DeepCopyInto(*out)
	}
	if in.Provisioned != nil {
		in, out := &in.Provisioned, &out.Provisioned
		*out = new(OSBState)
		(*in).DeepCopyInto(*out)
	}
	if in.ProvisionFailed != nil {
		in, out := &in.ProvisionFailed, &out.ProvisionFailed
		*out = new(OSBState)
		(*in).DeepCopyInto(*out)
	}
	if in.Deprovisioning != nil {
		in, out := &in.Deprovisioning, &out.Deprovisioning
		*out = new(OSBState)
		(*in).DeepCopyInto(*out)
	}
	if in.Deprovisioned != nil {
		in, out := &in.Deprovisioned, &out.Deprovisioned
		*out = new(OSBState)
		(*in).DeepCopyInto(*out)
	}
	if in.DeprovisionFailed != nil {
		in, out := &in.DeprovisionFailed, &out.DeprovisionFailed
		*out = new(OSBState)
		(*in).DeepCopyInto(*out)
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OSBStatus.
func (in *OSBStatus) DeepCopy() *OSBStatus {
	if in == nil {
		return nil
	}
	out := new(OSBStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in ObjectReferences) DeepCopyInto(out *ObjectReferences) {
	{
		in := &in
		*out = make(ObjectReferences, len(*in))
		copy(*out, *in)
		return
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ObjectReferences.
func (in ObjectReferences) DeepCopy() ObjectReferences {
	if in == nil {
		return nil
	}
	out := new(ObjectReferences)
	in.DeepCopyInto(out)
	return *out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *QualifiedRouteBinding) DeepCopyInto(out *QualifiedRouteBinding) {
	*out = *in
	out.Source = in.Source
	out.Destination = in.Destination
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new QualifiedRouteBinding.
func (in *QualifiedRouteBinding) DeepCopy() *QualifiedRouteBinding {
	if in == nil {
		return nil
	}
	out := new(QualifiedRouteBinding)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Route) DeepCopyInto(out *Route) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	out.Spec = in.Spec
	in.Status.DeepCopyInto(&out.Status)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Route.
func (in *Route) DeepCopy() *Route {
	if in == nil {
		return nil
	}
	out := new(Route)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Route) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RouteDestination) DeepCopyInto(out *RouteDestination) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RouteDestination.
func (in *RouteDestination) DeepCopy() *RouteDestination {
	if in == nil {
		return nil
	}
	out := new(RouteDestination)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RouteList) DeepCopyInto(out *RouteList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Route, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RouteList.
func (in *RouteList) DeepCopy() *RouteList {
	if in == nil {
		return nil
	}
	out := new(RouteList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *RouteList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RouteRef) DeepCopyInto(out *RouteRef) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RouteRef.
func (in *RouteRef) DeepCopy() *RouteRef {
	if in == nil {
		return nil
	}
	out := new(RouteRef)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RouteServiceBinding) DeepCopyInto(out *RouteServiceBinding) {
	*out = *in
	out.Source = in.Source
	if in.Destination != nil {
		in, out := &in.Destination, &out.Destination
		*out = new(RouteServiceURL)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RouteServiceBinding.
func (in *RouteServiceBinding) DeepCopy() *RouteServiceBinding {
	if in == nil {
		return nil
	}
	out := new(RouteServiceBinding)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RouteServiceDestination) DeepCopyInto(out *RouteServiceDestination) {
	*out = *in
	if in.RouteServiceURL != nil {
		in, out := &in.RouteServiceURL, &out.RouteServiceURL
		*out = new(RouteServiceURL)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RouteServiceDestination.
func (in *RouteServiceDestination) DeepCopy() *RouteServiceDestination {
	if in == nil {
		return nil
	}
	out := new(RouteServiceDestination)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RouteServiceURL) DeepCopyInto(out *RouteServiceURL) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RouteServiceURL.
func (in *RouteServiceURL) DeepCopy() *RouteServiceURL {
	if in == nil {
		return nil
	}
	out := new(RouteServiceURL)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RouteSpec) DeepCopyInto(out *RouteSpec) {
	*out = *in
	out.RouteSpecFields = in.RouteSpecFields
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RouteSpec.
func (in *RouteSpec) DeepCopy() *RouteSpec {
	if in == nil {
		return nil
	}
	out := new(RouteSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RouteSpecFields) DeepCopyInto(out *RouteSpecFields) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RouteSpecFields.
func (in *RouteSpecFields) DeepCopy() *RouteSpecFields {
	if in == nil {
		return nil
	}
	out := new(RouteSpecFields)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in RouteSpecFieldsSlice) DeepCopyInto(out *RouteSpecFieldsSlice) {
	{
		in := &in
		*out = make(RouteSpecFieldsSlice, len(*in))
		copy(*out, *in)
		return
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RouteSpecFieldsSlice.
func (in RouteSpecFieldsSlice) DeepCopy() RouteSpecFieldsSlice {
	if in == nil {
		return nil
	}
	out := new(RouteSpecFieldsSlice)
	in.DeepCopyInto(out)
	return *out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RouteStatus) DeepCopyInto(out *RouteStatus) {
	*out = *in
	in.Status.DeepCopyInto(&out.Status)
	out.RouteSpecFields = in.RouteSpecFields
	out.VirtualService = in.VirtualService
	if in.Bindings != nil {
		in, out := &in.Bindings, &out.Bindings
		*out = make([]RouteDestination, len(*in))
		copy(*out, *in)
	}
	if in.AppBindingDisplayNames != nil {
		in, out := &in.AppBindingDisplayNames, &out.AppBindingDisplayNames
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	out.RouteService = in.RouteService
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RouteStatus.
func (in *RouteStatus) DeepCopy() *RouteStatus {
	if in == nil {
		return nil
	}
	out := new(RouteStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RouteWeightBinding) DeepCopyInto(out *RouteWeightBinding) {
	*out = *in
	out.RouteSpecFields = in.RouteSpecFields
	if in.Weight != nil {
		in, out := &in.Weight, &out.Weight
		*out = new(int32)
		**out = **in
	}
	if in.DestinationPort != nil {
		in, out := &in.DestinationPort, &out.DestinationPort
		*out = new(int32)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RouteWeightBinding.
func (in *RouteWeightBinding) DeepCopy() *RouteWeightBinding {
	if in == nil {
		return nil
	}
	out := new(RouteWeightBinding)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Scale) DeepCopyInto(out *Scale) {
	*out = *in
	in.Scale.DeepCopyInto(&out.Scale)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Scale.
func (in *Scale) DeepCopy() *Scale {
	if in == nil {
		return nil
	}
	out := new(Scale)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Scale) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ScaleList) DeepCopyInto(out *ScaleList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Scale, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ScaleList.
func (in *ScaleList) DeepCopy() *ScaleList {
	if in == nil {
		return nil
	}
	out := new(ScaleList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *ScaleList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceBroker) DeepCopyInto(out *ServiceBroker) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceBroker.
func (in *ServiceBroker) DeepCopy() *ServiceBroker {
	if in == nil {
		return nil
	}
	out := new(ServiceBroker)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *ServiceBroker) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceBrokerList) DeepCopyInto(out *ServiceBrokerList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]ServiceBroker, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceBrokerList.
func (in *ServiceBrokerList) DeepCopy() *ServiceBrokerList {
	if in == nil {
		return nil
	}
	out := new(ServiceBrokerList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *ServiceBrokerList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceBrokerSpec) DeepCopyInto(out *ServiceBrokerSpec) {
	*out = *in
	in.CommonServiceBrokerSpec.DeepCopyInto(&out.CommonServiceBrokerSpec)
	out.Credentials = in.Credentials
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceBrokerSpec.
func (in *ServiceBrokerSpec) DeepCopy() *ServiceBrokerSpec {
	if in == nil {
		return nil
	}
	out := new(ServiceBrokerSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceFields) DeepCopyInto(out *ServiceFields) {
	*out = *in
	if in.Tags != nil {
		in, out := &in.Tags, &out.Tags
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceFields.
func (in *ServiceFields) DeepCopy() *ServiceFields {
	if in == nil {
		return nil
	}
	out := new(ServiceFields)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceInstance) DeepCopyInto(out *ServiceInstance) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceInstance.
func (in *ServiceInstance) DeepCopy() *ServiceInstance {
	if in == nil {
		return nil
	}
	out := new(ServiceInstance)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *ServiceInstance) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceInstanceBinding) DeepCopyInto(out *ServiceInstanceBinding) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceInstanceBinding.
func (in *ServiceInstanceBinding) DeepCopy() *ServiceInstanceBinding {
	if in == nil {
		return nil
	}
	out := new(ServiceInstanceBinding)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *ServiceInstanceBinding) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceInstanceBindingList) DeepCopyInto(out *ServiceInstanceBindingList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]ServiceInstanceBinding, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceInstanceBindingList.
func (in *ServiceInstanceBindingList) DeepCopy() *ServiceInstanceBindingList {
	if in == nil {
		return nil
	}
	out := new(ServiceInstanceBindingList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *ServiceInstanceBindingList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceInstanceBindingSpec) DeepCopyInto(out *ServiceInstanceBindingSpec) {
	*out = *in
	in.BindingType.DeepCopyInto(&out.BindingType)
	out.InstanceRef = in.InstanceRef
	out.ParametersFrom = in.ParametersFrom
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceInstanceBindingSpec.
func (in *ServiceInstanceBindingSpec) DeepCopy() *ServiceInstanceBindingSpec {
	if in == nil {
		return nil
	}
	out := new(ServiceInstanceBindingSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceInstanceBindingStatus) DeepCopyInto(out *ServiceInstanceBindingStatus) {
	*out = *in
	in.Status.DeepCopyInto(&out.Status)
	out.CredentialsSecretRef = in.CredentialsSecretRef
	in.ServiceFields.DeepCopyInto(&out.ServiceFields)
	if in.VolumeStatus != nil {
		in, out := &in.VolumeStatus, &out.VolumeStatus
		*out = new(BindingVolumeStatus)
		**out = **in
	}
	if in.RouteServiceURL != nil {
		in, out := &in.RouteServiceURL, &out.RouteServiceURL
		*out = new(RouteServiceURL)
		**out = **in
	}
	in.OSBStatus.DeepCopyInto(&out.OSBStatus)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceInstanceBindingStatus.
func (in *ServiceInstanceBindingStatus) DeepCopy() *ServiceInstanceBindingStatus {
	if in == nil {
		return nil
	}
	out := new(ServiceInstanceBindingStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceInstanceList) DeepCopyInto(out *ServiceInstanceList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]ServiceInstance, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceInstanceList.
func (in *ServiceInstanceList) DeepCopy() *ServiceInstanceList {
	if in == nil {
		return nil
	}
	out := new(ServiceInstanceList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *ServiceInstanceList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceInstanceSpec) DeepCopyInto(out *ServiceInstanceSpec) {
	*out = *in
	in.ServiceType.DeepCopyInto(&out.ServiceType)
	if in.Tags != nil {
		in, out := &in.Tags, &out.Tags
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	out.ParametersFrom = in.ParametersFrom
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceInstanceSpec.
func (in *ServiceInstanceSpec) DeepCopy() *ServiceInstanceSpec {
	if in == nil {
		return nil
	}
	out := new(ServiceInstanceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceInstanceStatus) DeepCopyInto(out *ServiceInstanceStatus) {
	*out = *in
	in.Status.DeepCopyInto(&out.Status)
	in.ServiceFields.DeepCopyInto(&out.ServiceFields)
	if in.RouteServiceURL != nil {
		in, out := &in.RouteServiceURL, &out.RouteServiceURL
		*out = new(RouteServiceURL)
		**out = **in
	}
	in.OSBStatus.DeepCopyInto(&out.OSBStatus)
	if in.VolumeStatus != nil {
		in, out := &in.VolumeStatus, &out.VolumeStatus
		*out = new(VolumeStatus)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceInstanceStatus.
func (in *ServiceInstanceStatus) DeepCopy() *ServiceInstanceStatus {
	if in == nil {
		return nil
	}
	out := new(ServiceInstanceStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceOffering) DeepCopyInto(out *ServiceOffering) {
	*out = *in
	if in.Tags != nil {
		in, out := &in.Tags, &out.Tags
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.Plans != nil {
		in, out := &in.Plans, &out.Plans
		*out = make([]ServicePlan, len(*in))
		copy(*out, *in)
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceOffering.
func (in *ServiceOffering) DeepCopy() *ServiceOffering {
	if in == nil {
		return nil
	}
	out := new(ServiceOffering)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServicePlan) DeepCopyInto(out *ServicePlan) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServicePlan.
func (in *ServicePlan) DeepCopy() *ServicePlan {
	if in == nil {
		return nil
	}
	out := new(ServicePlan)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ServiceType) DeepCopyInto(out *ServiceType) {
	*out = *in
	if in.UPS != nil {
		in, out := &in.UPS, &out.UPS
		*out = new(UPSInstance)
		(*in).DeepCopyInto(*out)
	}
	if in.Brokered != nil {
		in, out := &in.Brokered, &out.Brokered
		*out = new(BrokeredInstance)
		**out = **in
	}
	if in.Volume != nil {
		in, out := &in.Volume, &out.Volume
		*out = new(OSBInstance)
		**out = **in
	}
	if in.OSB != nil {
		in, out := &in.OSB, &out.OSB
		*out = new(OSBInstance)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ServiceType.
func (in *ServiceType) DeepCopy() *ServiceType {
	if in == nil {
		return nil
	}
	out := new(ServiceType)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SourcePackage) DeepCopyInto(out *SourcePackage) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	out.Spec = in.Spec
	in.Status.DeepCopyInto(&out.Status)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SourcePackage.
func (in *SourcePackage) DeepCopy() *SourcePackage {
	if in == nil {
		return nil
	}
	out := new(SourcePackage)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *SourcePackage) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SourcePackageChecksum) DeepCopyInto(out *SourcePackageChecksum) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SourcePackageChecksum.
func (in *SourcePackageChecksum) DeepCopy() *SourcePackageChecksum {
	if in == nil {
		return nil
	}
	out := new(SourcePackageChecksum)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SourcePackageList) DeepCopyInto(out *SourcePackageList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]SourcePackage, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SourcePackageList.
func (in *SourcePackageList) DeepCopy() *SourcePackageList {
	if in == nil {
		return nil
	}
	out := new(SourcePackageList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *SourcePackageList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SourcePackageSpec) DeepCopyInto(out *SourcePackageSpec) {
	*out = *in
	out.Checksum = in.Checksum
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SourcePackageSpec.
func (in *SourcePackageSpec) DeepCopy() *SourcePackageSpec {
	if in == nil {
		return nil
	}
	out := new(SourcePackageSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SourcePackageStatus) DeepCopyInto(out *SourcePackageStatus) {
	*out = *in
	in.Status.DeepCopyInto(&out.Status)
	out.Checksum = in.Checksum
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SourcePackageStatus.
func (in *SourcePackageStatus) DeepCopy() *SourcePackageStatus {
	if in == nil {
		return nil
	}
	out := new(SourcePackageStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Space) DeepCopyInto(out *Space) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Space.
func (in *Space) DeepCopy() *Space {
	if in == nil {
		return nil
	}
	out := new(Space)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Space) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SpaceDomain) DeepCopyInto(out *SpaceDomain) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SpaceDomain.
func (in *SpaceDomain) DeepCopy() *SpaceDomain {
	if in == nil {
		return nil
	}
	out := new(SpaceDomain)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in SpaceDomains) DeepCopyInto(out *SpaceDomains) {
	{
		in := &in
		*out = make(SpaceDomains, len(*in))
		copy(*out, *in)
		return
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SpaceDomains.
func (in SpaceDomains) DeepCopy() SpaceDomains {
	if in == nil {
		return nil
	}
	out := new(SpaceDomains)
	in.DeepCopyInto(out)
	return *out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SpaceList) DeepCopyInto(out *SpaceList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Space, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SpaceList.
func (in *SpaceList) DeepCopy() *SpaceList {
	if in == nil {
		return nil
	}
	out := new(SpaceList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *SpaceList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SpaceSpec) DeepCopyInto(out *SpaceSpec) {
	*out = *in
	in.BuildConfig.DeepCopyInto(&out.BuildConfig)
	in.RuntimeConfig.DeepCopyInto(&out.RuntimeConfig)
	in.NetworkConfig.DeepCopyInto(&out.NetworkConfig)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SpaceSpec.
func (in *SpaceSpec) DeepCopy() *SpaceSpec {
	if in == nil {
		return nil
	}
	out := new(SpaceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SpaceSpecBuildConfig) DeepCopyInto(out *SpaceSpecBuildConfig) {
	*out = *in
	if in.Env != nil {
		in, out := &in.Env, &out.Env
		*out = make([]v1.EnvVar, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.DefaultToV3Stack != nil {
		in, out := &in.DefaultToV3Stack, &out.DefaultToV3Stack
		*out = new(bool)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SpaceSpecBuildConfig.
func (in *SpaceSpecBuildConfig) DeepCopy() *SpaceSpecBuildConfig {
	if in == nil {
		return nil
	}
	out := new(SpaceSpecBuildConfig)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SpaceSpecNetworkConfig) DeepCopyInto(out *SpaceSpecNetworkConfig) {
	*out = *in
	if in.Domains != nil {
		in, out := &in.Domains, &out.Domains
		*out = make([]SpaceDomain, len(*in))
		copy(*out, *in)
	}
	out.AppNetworkPolicy = in.AppNetworkPolicy
	out.BuildNetworkPolicy = in.BuildNetworkPolicy
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SpaceSpecNetworkConfig.
func (in *SpaceSpecNetworkConfig) DeepCopy() *SpaceSpecNetworkConfig {
	if in == nil {
		return nil
	}
	out := new(SpaceSpecNetworkConfig)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SpaceSpecNetworkConfigPolicy) DeepCopyInto(out *SpaceSpecNetworkConfigPolicy) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SpaceSpecNetworkConfigPolicy.
func (in *SpaceSpecNetworkConfigPolicy) DeepCopy() *SpaceSpecNetworkConfigPolicy {
	if in == nil {
		return nil
	}
	out := new(SpaceSpecNetworkConfigPolicy)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SpaceSpecRuntimeConfig) DeepCopyInto(out *SpaceSpecRuntimeConfig) {
	*out = *in
	if in.Env != nil {
		in, out := &in.Env, &out.Env
		*out = make([]v1.EnvVar, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.NodeSelector != nil {
		in, out := &in.NodeSelector, &out.NodeSelector
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SpaceSpecRuntimeConfig.
func (in *SpaceSpecRuntimeConfig) DeepCopy() *SpaceSpecRuntimeConfig {
	if in == nil {
		return nil
	}
	out := new(SpaceSpecRuntimeConfig)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SpaceStatus) DeepCopyInto(out *SpaceStatus) {
	*out = *in
	in.Status.DeepCopyInto(&out.Status)
	in.RuntimeConfig.DeepCopyInto(&out.RuntimeConfig)
	in.NetworkConfig.DeepCopyInto(&out.NetworkConfig)
	in.BuildConfig.DeepCopyInto(&out.BuildConfig)
	if in.IngressGateways != nil {
		in, out := &in.IngressGateways, &out.IngressGateways
		*out = make([]v1.LoadBalancerIngress, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SpaceStatus.
func (in *SpaceStatus) DeepCopy() *SpaceStatus {
	if in == nil {
		return nil
	}
	out := new(SpaceStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SpaceStatusBuildConfig) DeepCopyInto(out *SpaceStatusBuildConfig) {
	*out = *in
	if in.BuildpacksV2 != nil {
		in, out := &in.BuildpacksV2, &out.BuildpacksV2
		*out = make(config.BuildpackV2List, len(*in))
		copy(*out, *in)
	}
	if in.StacksV2 != nil {
		in, out := &in.StacksV2, &out.StacksV2
		*out = make(config.StackV2List, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.StacksV3 != nil {
		in, out := &in.StacksV3, &out.StacksV3
		*out = make(config.StackV3List, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.Env != nil {
		in, out := &in.Env, &out.Env
		*out = make([]v1.EnvVar, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SpaceStatusBuildConfig.
func (in *SpaceStatusBuildConfig) DeepCopy() *SpaceStatusBuildConfig {
	if in == nil {
		return nil
	}
	out := new(SpaceStatusBuildConfig)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SpaceStatusNetworkConfig) DeepCopyInto(out *SpaceStatusNetworkConfig) {
	*out = *in
	if in.Domains != nil {
		in, out := &in.Domains, &out.Domains
		*out = make([]SpaceDomain, len(*in))
		copy(*out, *in)
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SpaceStatusNetworkConfig.
func (in *SpaceStatusNetworkConfig) DeepCopy() *SpaceStatusNetworkConfig {
	if in == nil {
		return nil
	}
	out := new(SpaceStatusNetworkConfig)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SpaceStatusRuntimeConfig) DeepCopyInto(out *SpaceStatusRuntimeConfig) {
	*out = *in
	if in.Env != nil {
		in, out := &in.Env, &out.Env
		*out = make([]v1.EnvVar, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.AppCPUPerGBOfRAM != nil {
		in, out := &in.AppCPUPerGBOfRAM, &out.AppCPUPerGBOfRAM
		x := (*in).DeepCopy()
		*out = &x
	}
	if in.AppCPUMin != nil {
		in, out := &in.AppCPUMin, &out.AppCPUMin
		x := (*in).DeepCopy()
		*out = &x
	}
	if in.ProgressDeadlineSeconds != nil {
		in, out := &in.ProgressDeadlineSeconds, &out.ProgressDeadlineSeconds
		*out = new(int32)
		**out = **in
	}
	if in.TerminationGracePeriodSeconds != nil {
		in, out := &in.TerminationGracePeriodSeconds, &out.TerminationGracePeriodSeconds
		*out = new(int64)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SpaceStatusRuntimeConfig.
func (in *SpaceStatusRuntimeConfig) DeepCopy() *SpaceStatusRuntimeConfig {
	if in == nil {
		return nil
	}
	out := new(SpaceStatusRuntimeConfig)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Task) DeepCopyInto(out *Task) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	out.Spec = in.Spec
	in.Status.DeepCopyInto(&out.Status)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Task.
func (in *Task) DeepCopy() *Task {
	if in == nil {
		return nil
	}
	out := new(Task)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Task) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TaskList) DeepCopyInto(out *TaskList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Task, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TaskList.
func (in *TaskList) DeepCopy() *TaskList {
	if in == nil {
		return nil
	}
	out := new(TaskList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *TaskList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TaskSchedule) DeepCopyInto(out *TaskSchedule) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	out.Spec = in.Spec
	in.Status.DeepCopyInto(&out.Status)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TaskSchedule.
func (in *TaskSchedule) DeepCopy() *TaskSchedule {
	if in == nil {
		return nil
	}
	out := new(TaskSchedule)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *TaskSchedule) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TaskScheduleList) DeepCopyInto(out *TaskScheduleList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]TaskSchedule, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TaskScheduleList.
func (in *TaskScheduleList) DeepCopy() *TaskScheduleList {
	if in == nil {
		return nil
	}
	out := new(TaskScheduleList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *TaskScheduleList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TaskScheduleSpec) DeepCopyInto(out *TaskScheduleSpec) {
	*out = *in
	out.TaskTemplate = in.TaskTemplate
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TaskScheduleSpec.
func (in *TaskScheduleSpec) DeepCopy() *TaskScheduleSpec {
	if in == nil {
		return nil
	}
	out := new(TaskScheduleSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TaskScheduleStatus) DeepCopyInto(out *TaskScheduleStatus) {
	*out = *in
	in.Status.DeepCopyInto(&out.Status)
	in.TaskScheduleStatusFields.DeepCopyInto(&out.TaskScheduleStatusFields)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TaskScheduleStatus.
func (in *TaskScheduleStatus) DeepCopy() *TaskScheduleStatus {
	if in == nil {
		return nil
	}
	out := new(TaskScheduleStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TaskScheduleStatusFields) DeepCopyInto(out *TaskScheduleStatusFields) {
	*out = *in
	if in.Active != nil {
		in, out := &in.Active, &out.Active
		*out = make([]v1.LocalObjectReference, len(*in))
		copy(*out, *in)
	}
	if in.LastScheduleTime != nil {
		in, out := &in.LastScheduleTime, &out.LastScheduleTime
		*out = (*in).DeepCopy()
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TaskScheduleStatusFields.
func (in *TaskScheduleStatusFields) DeepCopy() *TaskScheduleStatusFields {
	if in == nil {
		return nil
	}
	out := new(TaskScheduleStatusFields)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TaskSpec) DeepCopyInto(out *TaskSpec) {
	*out = *in
	out.AppRef = in.AppRef
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TaskSpec.
func (in *TaskSpec) DeepCopy() *TaskSpec {
	if in == nil {
		return nil
	}
	out := new(TaskSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TaskStatus) DeepCopyInto(out *TaskStatus) {
	*out = *in
	in.Status.DeepCopyInto(&out.Status)
	in.TaskStatusFields.DeepCopyInto(&out.TaskStatusFields)
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TaskStatus.
func (in *TaskStatus) DeepCopy() *TaskStatus {
	if in == nil {
		return nil
	}
	out := new(TaskStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TaskStatusFields) DeepCopyInto(out *TaskStatusFields) {
	*out = *in
	if in.StartTime != nil {
		in, out := &in.StartTime, &out.StartTime
		*out = (*in).DeepCopy()
	}
	if in.CompletionTime != nil {
		in, out := &in.CompletionTime, &out.CompletionTime
		*out = (*in).DeepCopy()
	}
	if in.Duration != nil {
		in, out := &in.Duration, &out.Duration
		*out = new(metav1.Duration)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TaskStatusFields.
func (in *TaskStatusFields) DeepCopy() *TaskStatusFields {
	if in == nil {
		return nil
	}
	out := new(TaskStatusFields)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *UPSInstance) DeepCopyInto(out *UPSInstance) {
	*out = *in
	if in.RouteServiceURL != nil {
		in, out := &in.RouteServiceURL, &out.RouteServiceURL
		*out = new(RouteServiceURL)
		**out = **in
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new UPSInstance.
func (in *UPSInstance) DeepCopy() *UPSInstance {
	if in == nil {
		return nil
	}
	out := new(UPSInstance)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *URL) DeepCopyInto(out *URL) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new URL.
func (in *URL) DeepCopy() *URL {
	if in == nil {
		return nil
	}
	out := new(URL)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *UidGid) DeepCopyInto(out *UidGid) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new UidGid.
func (in *UidGid) DeepCopy() *UidGid {
	if in == nil {
		return nil
	}
	out := new(UidGid)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *VolumeBrokerSpec) DeepCopyInto(out *VolumeBrokerSpec) {
	*out = *in
	if in.VolumeOfferings != nil {
		in, out := &in.VolumeOfferings, &out.VolumeOfferings
		*out = make([]ServiceOffering, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new VolumeBrokerSpec.
func (in *VolumeBrokerSpec) DeepCopy() *VolumeBrokerSpec {
	if in == nil {
		return nil
	}
	out := new(VolumeBrokerSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *VolumeInstanceParams) DeepCopyInto(out *VolumeInstanceParams) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new VolumeInstanceParams.
func (in *VolumeInstanceParams) DeepCopy() *VolumeInstanceParams {
	if in == nil {
		return nil
	}
	out := new(VolumeInstanceParams)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *VolumeStatus) DeepCopyInto(out *VolumeStatus) {
	*out = *in
	return
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new VolumeStatus.
func (in *VolumeStatus) DeepCopy() *VolumeStatus {
	if in == nil {
		return nil
	}
	out := new(VolumeStatus)
	in.DeepCopyInto(out)
	return out
}
